Public Class clsTranscribe

    Public Sub Transcribe(ByVal src As TextBox, ByVal op As TextBox)
        Dim i As Long
        Dim x As String
        Dim y As String
        x = src.Text
        y = ""

        Dim chararray As Char()
        chararray = x.ToCharArray()

        '-- Walk around string and process character in turn
        For i = 0 To chararray.Length - 1
            ' display each character in hex
            'MsgBox(Hex(AscW(chararray(i))))

            '-- handle underscore for unpronounced letters as brackets
            '-- look ahead one character to see if there is an underscore under the current character
            If i < chararray.Length - 1 Then
                If AscW(chararray(i + 1)) = &H331 Then
                    y = y + "("
                End If
            End If

            '-- Process current character 
            y = y + cvt(AscW(chararray(i)))
        Next i

        op.Text = y
    End Sub

    Public Function cvt(ByRef c As Integer) As Char
        Select Case c
            Case &H710
                cvt = ChrW(&H2019)    '-- alap
            Case &H712
                cvt = "b"
            Case &H713
                cvt = "g"
            Case &H715
                cvt = "d"
            Case &H717
                cvt = "h"
            Case &H718
                cvt = "w"
            Case &H719
                cvt = "z"
            Case &H71A
                cvt = ChrW(&H1E25)    '-- het
            Case &H71B
                cvt = ChrW(&H1E6D)    '-- tet
            Case &H71D
                cvt = "y"
            Case &H71F
                cvt = "k"
            Case &H720
                cvt = "l"
            Case &H721
                cvt = "m"
            Case &H722
                cvt = "n"
            Case &H723
                cvt = "s"
            Case &H725
                cvt = ChrW(&H2018)    '-- ayin
            Case &H726
                cvt = "p"
            Case &H728
                cvt = ChrW(&H1E63)    '-- tsade
            Case &H729
                cvt = "q"
            Case &H72A
                cvt = "r"
            Case &H72B
                cvt = ChrW(&H161)    '-- shin
            Case &H72C
                cvt = "t"
            Case &H730, &H731
                cvt = "a"
            Case &H733, &H734
                cvt = ChrW(&H101)    '-- zqafa
            Case &H736, &H737
                cvt = "e"   '-- rhbasa
            Case &H73A, &H73B
                cvt = "i"   '-- hbasa
            Case &H73D, &H73E
                cvt = "u"   '-- esasa/usoso
            Case &H331
                cvt = ")"
            Case Else  '-- passthrough
                cvt = ChrW(c)
        End Select
    End Function

    Public Sub TranscribeAsHTMLCodes(ByVal src As TextBox, ByVal op As TextBox)
        Dim i As Long
        Dim x As String
        Dim y As String
        x = src.Text
        y = ""

        Dim chararray As Char()
        chararray = x.ToCharArray()

        '-- Walk around string and process character in turn
        For i = 0 To chararray.Length - 1
            ' display each character in hex
            'MsgBox(Hex(AscW(chararray(i))))

            '-- Process current character 
            y = y + "&#x" + Hex(AscW(chararray(i))) + ";"
        Next i

        op.Text = y
    End Sub

End Class
